<?php

namespace AmazingCat\ZipGate\Block;

use AmazingCat\ZipGate\Helper\ZipCodeHelper;
use Magento\Framework\View\Element\Template;

class ZipGateHeader extends Template
{
    /**
     * @var ZipCodeHelper
     */
    protected $zipCodeHelper;

    /**
     * ZipGateHeader constructor.
     * @param Template\Context $context
     * @param ZipCodeHelper $zipCodeHelper
     * @param array $data
     */
    public function __construct(Template\Context $context, ZipCodeHelper $zipCodeHelper, array $data = [])
    {
        parent::__construct($context, $data);
        $this->zipCodeHelper = $zipCodeHelper;
    }

    public function getCurrentZip()
    {
        return $this->zipCodeHelper->getZipCode();
    }

    protected function getCacheLifetime()
    {
        return null;
    }
}
