<?php


namespace AmazingCat\ZipGate\Block;

use AmazingCat\ZipGate\Helper\ZipCodeHelper;
use Magento\Framework\UrlInterface;
use Magento\Framework\View\Element\Template;

class ZipGateModal extends ZipGateHeader
{
    /**
     * @var UrlInterface
     */
    protected $urlBuilder;

    /**
     * ZipGateModal constructor.
     * @param Template\Context $context
     * @param ZipCodeHelper $zipCodeHelper
     * @param UrlInterface $urlBuilder
     * @param array $data
     */
    public function __construct(
        Template\Context $context,
        ZipCodeHelper $zipCodeHelper,
        UrlInterface $urlBuilder,
        array $data = []
    ) {
        parent::__construct($context, $zipCodeHelper, $data);
        $this->urlBuilder = $urlBuilder;
    }

    public function getFormSubmitUrl()
    {
        return $this->getUrl('zipgate/code/apply');
    }
}
