<?php


namespace AmazingCat\ZipGate\Model\DataProviders\ZipCode\Form;

use AmazingCat\ZipGate\Model\ResourceModel\ZipCode\CollectionFactory as ZipCodeCollectionFactory;
use Magento\Ui\DataProvider\AbstractDataProvider;

class DataProvider extends AbstractDataProvider
{

    /**
     * @var array
     */
    protected $loadedData;

    /**
     * @var ZipCodeCollectionFactory
     */
    protected $zipCodeCollectionFactory;

    /**
     * DataProvider constructor.
     * @param ZipCodeCollectionFactory $zipCodeCollectionFactory
     * @param string $name
     * @param string $primaryFieldName
     * @param string $requestFieldName
     * @param array $meta
     * @param array $data
     */
    public function __construct(
        ZipCodeCollectionFactory $zipCodeCollectionFactory,
        string $name,
        string $primaryFieldName,
        string $requestFieldName,
        array $meta = [],
        array $data = []
    ) {
        parent::__construct($name, $primaryFieldName, $requestFieldName, $meta, $data);
        $this->collection = $zipCodeCollectionFactory->create();
    }

    public function getData()
    {
        if (!empty($this->loadedData)) {
            return $this->loadedData;
        }

        $items = $this->collection->getItems();

        foreach ($items as $code) {
            $this->loadedData[$code->getId()] = $code->getData();
        }

        return $this->loadedData;
    }
}
