<?php

namespace AmazingCat\ZipGate\Model;

use Magento\Framework\DataObject;
use Magento\Framework\Model\AbstractModel;

class ZipLog extends AbstractModel
{
    /**
     * @var ZipLog
     */
    protected $zipLog;

    /**
     * ZipLog constructor.
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param ResourceModel\ZipLog $zipLog
     * @param \Magento\Framework\Model\ResourceModel\AbstractResource|null $resource
     * @param \Magento\Framework\Data\Collection\AbstractDb|null $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        ResourceModel\ZipLog $zipLog,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
        $this->zipLog = $zipLog;
    }

    protected function _construct()
    {
        $this->_init(ResourceModel\ZipLog::class);
    }

    /**
     * @param bool $successFlag
     * @param string $message
     * @param mixed $zipCode
     * @throws \Exception
     */
    public function log(bool $successFlag, string $message, $zipCode)
    {
        $this->setData([
            'status' => $successFlag ? 'Success' : 'Failure',
            'message' => $message,
            'zip_code' => $zipCode,
            'created_at' =>  (new \DateTime())->format('Y-m-d H:i:s')
        ]);

        $this->zipLog->save($this);
    }
}
