<?php

namespace AmazingCat\ZipGate\Observer;

use AmazingCat\ZipGate\Model\ResourceModel\ZipLog;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Exception\AlreadyExistsException;
use Zend\Log\Logger;

class CodeApplicationObserver implements ObserverInterface
{
    /**
     * @var \AmazingCat\ZipGate\Model\ZipLogFactory
     */
    protected $zipLogFactory;

    /**
     * CodeApplicationObserver constructor.
     * @param \AmazingCat\ZipGate\Model\ZipLogFactory $zipLogFactory
     */
    public function __construct(
        \AmazingCat\ZipGate\Model\ZipLogFactory $zipLogFactory
    ) {
        $this->zipLogFactory = $zipLogFactory;
    }

    /**
     * @param Observer $observer
     * @return void
     * @throws \Exception
     */
    public function execute(Observer $observer)
    {
        $logDto = $this->getModel();
        $logDto->log($observer->getIsSuccess(), $observer->getMessage(), $observer->getZipCode());
    }

    /**
     * @return \AmazingCat\ZipGate\Model\ZipLog
     */
    protected function getModel()
    {
        return $this->zipLogFactory->create();
    }
}
