<?php

namespace AmazingCat\ZipGate\Ui\Component\Grid\Column;

use Magento\Framework\View\Element\UiComponent\ContextInterface;
use Magento\Framework\View\Element\UiComponentFactory;
use Magento\Ui\Component\Listing\Columns\Column;

class StoreViewColumn extends Column
{
    /**
     * @var \Magento\Store\Model\ResourceModel\Store\CollectionFactory
     */
    protected $storeManager;

    /**
     * StoreViewColumn constructor.
     * @param ContextInterface $context
     * @param UiComponentFactory $uiComponentFactory
     * @param \Magento\Store\Model\ResourceModel\Store\CollectionFactory $storeCollectionFactory
     * @param array $components
     * @param array $data
     */
    public function __construct(
        ContextInterface $context,
        UiComponentFactory $uiComponentFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManagerInterface,
        array $components = [],
        array $data = []
    ) {
        parent::__construct($context, $uiComponentFactory, $components, $data);
        $this->storeManager = $storeManagerInterface;
    }

    public function prepareDataSource(array $dataSource)
    {
        if (isset($dataSource['data']['items'])) {
            foreach ($dataSource['data']['items'] as &$item) {
                $storeId = $item['storeview_id'];

                try {
                    $store = $this->storeManager->getStore($storeId);
                    $item['storeview'] = $store->getName() . ' [' . $store->getCode() . ']';
                } catch (\Throwable $e) {
                    $item['storeview'] = 'Store with store id ' . $storeId . ' not found';
                    continue;
                }
            }
        }
        return $dataSource;
    }
}
