require([
    'jquery',
    'Magento_Ui/js/modal/modal',
    'mage/translate'
], ($, modal, trans) => {
    const ModalController = {
        init() {
            this.loadModal()
                .then((popup) => {
                    console.log('Modal initialized');
                })
                .catch((error) => {
                    console.log(error);
                })
        },

        bind(elementSelector, event, callback) {
            $(elementSelector).on(event, callback);
        },

        loadModal() {
            let modalContent = $("#zipgate-modal");
            let popup = null;
            if (modalContent.length) {
                const modalOptions = {
                    type: 'popup',
                    responsive: true,
                    innerScroll: false,
                    modalClass: 'zipgate__modal-content',
                    buttons: []
                };
                popup = modal(modalOptions, modalContent);
                this.bind("#zipgate-btn", 'click', function () {
                    $("#zipgate-modal").modal("openModal");
                })
            }
            return new Promise((resolve, reject) => {
                if (popup) {
                    resolve(popup)
                } else {
                    reject('Popup window can\'t be initialized');
                }
            })
        }
    };

    ModalController.init();
});
